<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:saxon="http://icl.com/saxon" extension-element-prefixes="saxon" version="1.0">  

<xsl:output method="html" indent="yes"/>

<xsl:key name="element" match="element" use="@name"/>
<xsl:key name="attribute" match="attribute" use="@name"/>
<xsl:key name="child" match="child" use="@name"/>

<xsl:template match="/">
  <html>
    <head>
      <link rel="stylesheet" type="text/css" href="../CSS/style.css"/>
    </head>
    <body>
      <h1>Comparison of Strict and Transitional XHTML:</h1>
      <h3>Following transitional elements were removed from the Strict XHTML:</h3>
      <p>
	<xsl:apply-templates select="/elements/element[not(dtd/@name='Strict') and dtd/@name='Transitional']"/>
	<xsl:text>.</xsl:text>
      </p>
      <hr/>
      <h3>Following attributes were removed from the  Strict XHTML:</h3>
      <p>
	<xsl:apply-templates select="/elements/element[dtd/@name='Strict']/attribute">
	  <xsl:sort select="@name"/>
	</xsl:apply-templates>
      </p>
      <hr/>
      <h3>Following elements cannot occur in the given context in the Strict XHTML:</h3>
      <p>
	<xsl:apply-templates select="/elements/element[dtd/@name='Strict']" mode="child"/>
      </p>
      <p>
	<xsl:apply-templates select="//child[dtd/@name='Transitional' and not(dtd/@name='Strict')][parent::element/dtd/@name = 'Strict' and (key('element',@name)/dtd/@name='Strict') and parent::element/@name='blockquote']"  mode="printP"/>
	<xsl:apply-templates select="//child[dtd/@name='Transitional' and not(dtd/@name='Strict')][parent::element/dtd/@name = 'Strict' and (key('element',@name)/dtd/@name='Strict') and parent::element/@name='body']"  mode="printP"/>
	<xsl:apply-templates select="//child[dtd/@name='Transitional' and not(dtd/@name='Strict')][parent::element/dtd/@name = 'Strict' and (key('element',@name)/dtd/@name='Strict') and parent::element/@name='form']"  mode="printP"/>
	<xsl:apply-templates select="//child[dtd/@name='Transitional' and not(dtd/@name='Strict')][parent::element/dtd/@name = 'Strict' and (key('element',@name)/dtd/@name='Strict') and parent::element/@name='noscript']"  mode="printP"/>
      </p>
    </body>
  </html>
</xsl:template>


<xsl:template match="child" mode="printP">
  <xsl:if test="position()=1">
    <br/>
    <xsl:text>Element </xsl:text>
    <a href="Strict/el_{@name}.html" class="element"><xsl:value-of select="parent::element/@name"/></a>
    <xsl:text> cannot contain </xsl:text>
    </xsl:if>
    <a href="Strict/el_{@name}.html" class="element">
      <xsl:if test="@name='PCDATA'">#</xsl:if>
      <xsl:value-of select="@name"/>
    </a>

    <xsl:choose>
      <xsl:when test="not(position()=last())">
	<xsl:text>, </xsl:text>
      </xsl:when>
      <xsl:otherwise>
	<xsl:text> as children.</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

<xsl:template match="element">
  <a class="element" href="Transitional/el_{@name}.html"><xsl:value-of select="@name"/></a>
  <xsl:if test="not(position()=last())">
    <xsl:text>, </xsl:text>
  </xsl:if>
</xsl:template>

<xsl:template match="attribute">
  <xsl:if test="generate-id()= generate-id(key('attribute',@name))">
    <xsl:variable name="xxx" 
      select="key('attribute',@name)[not(dtd/@name='Strict')]/parent::element[dtd/@name='Strict']"/>
      <xsl:if test="$xxx">
	<xsl:text>Attribute </xsl:text>
	<a class="attribute" href="Transitional/attr_{@name}.html"><xsl:value-of select="@name"/></a> 
	<xsl:text> is forbidden on </xsl:text>
	  <xsl:apply-templates select="$xxx"/>
	  <xsl:variable name="yyy" 
	    select="key('attribute',@name)[dtd/@name='Strict']/parent::element[dtd/@name='Strict']"/>
	    <xsl:if test="$yyy">
	      <xsl:text>, it can be used on </xsl:text>
	      <xsl:apply-templates select="$yyy"/> 
	    </xsl:if>
	    <xsl:text>.</xsl:text>
	  <br/>
	</xsl:if>
  </xsl:if>
</xsl:template>

<xsl:template match="child" mode="parent">
  <a href="Strict/el_{@name}.html" class="element">
    <xsl:value-of select="parent::element/@name"/>
  </a>
  <xsl:if test="not(position()=last())">
    <xsl:text>, </xsl:text>
  </xsl:if>
</xsl:template>

<xsl:template match="element" mode="child">
  <xsl:variable name="xxx" select="key('child',@name)[parent::element[dtd/@name='Strict']][not(dtd/@name='Strict')]"/>

  <xsl:if test="$xxx">
    <xsl:if test="not(@name='PCDATA')">
      <xsl:text>Element </xsl:text>
    </xsl:if>
    <a class="element" href="Strict/el_{@name}.html">
      <xsl:if test="@name='PCDATA'">#</xsl:if>
      <xsl:value-of select="@name"/>
    </a> 
    <xsl:text> cannot be a child of </xsl:text>
    <xsl:apply-templates select="$xxx" mode="parent"/>
    <xsl:text>.</xsl:text>
    <br/>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>








